* Ŀ *
*   PROG NAME: PROCLIB.PRG - procedure file.                            *
*   Copyright (c) 1989, 1990 Tech III, Inc. All rights reserved.        *
*   Tech III of San Pedro, California      (213) 547-2191.              *
*   "The bridge connecting people and technology."(tm)                  *
*  *

* Ŀ *
*   SYSTEM FUNCTIONS                                                    *
*  *
 
FUNCTION custpaym
  * custpaym() == returns total of all payments for customer currently
  *               pointed to in customer file, payments must be open,
  *               all pointers will be restored
  PRIVATE mtotal, mrecno
  STORE SUBSTR('ABCDEFGHIJ',SELECT(),1) TO marea
  SELECT payments
  SET ORDER TO cus_cus
  IF EOF()
    GO BOTTOM
  ENDIF
  mrecno = RECNO()
  SEEK customer->cust_id
  SUM REST amount TO mtotal WHILE cust_id = customer->cust_id
  IF .NOT. BOF() .AND. mrecno <= RECCOUNT() .AND. mrecno > 0
    GOTO mrecno
  ENDIF
  SELECT &marea.
  RETURN mtotal
  
FUNCTION custsales
  * custsales() == returns total of all invoices for customer currently
  *                pointed to in customer file, lineitems must be open
  *                as alias lines, all pointers will be restored
  *
  PRIVATE mtotal, mrecno1, mrecno2
  STORE SUBSTR('ABCDEFGHIJ',SELECT(),1) TO area
  STORE 0 TO mtotal
  SELECT lines
  STORE RECNO() TO mrecno2
  SELECT customer
  STORE cust_id TO mcust_id
  SELECT invoice
  STORE RECNO() TO mrecno1
  SET ORDER TO inv_cus
  SEEK mcust_id
  SUM REST INVSUB() + INVTAX() TO mtotal WHILE cust_id = mcust_id
  SELECT invoice
  SET ORDER TO inv_inv
  IF .NOT. BOF() .AND. mrecno1 <= RECCOUNT() .AND. mrecno1 # 0
    GOTO mrecno1
  ENDIF
  SELECT lines
  IF .NOT. BOF() .AND. mrecno2 <= RECCOUNT() .AND. mrecno2 # 0
    GOTO mrecno2
  ENDIF
  SELECT customer
  SEEK mcust_id
  SELECT &area
  RETURN mtotal
  
FUNCTION invsub
  * Returns subtotal of current invoice
  PRIVATE mrecno, subtot, area, curorder
  STORE SUBSTR('ABCDEFGHIJ',SELECT(),1) TO area
  STORE ORDER() TO curorder
  SELECT lines
  SET ORDER TO lns_inv
  mrecno = RECNO()
  SEEK invoice->invoice
  STORE 0 TO subtot
  SUM REST price*quantity TO subtot WHILE lines->invoice = invoice->invoice
  IF .NOT. BOF() .AND. mrecno <= RECCOUNT() .AND. mrecno # 0
    GOTO mrecno
  ENDIF
  SELECT &area
  SET ORDER TO &curorder
  RETURN subtot
  
FUNCTION invtax
  * Returns tax for current invoice
  PRIVATE mrecno, taxtot, area, curorder
  STORE SUBSTR('ABCDEFGHIJ',SELECT(),1) TO area
  STORE ORDER() TO curorder
  SELECT lines
  SET ORDER TO lns_inv
  mrecno = RECNO()
  SEEK invoice->invoice
  STORE 0 TO taxtot
  SUM REST price*quantity*invoice->taxrate/100 FOR taxable TO taxtot ;
  WHILE lines->invoice = invoice->invoice
  STORE ROUND(taxtot,2) TO taxtot
  IF .NOT. BOF() .AND. mrecno <= RECCOUNT() .AND. mrecno # 0
    GOTO mrecno
  ENDIF
  SELECT &area
  SET ORDER TO &curorder
  RETURN taxtot
  
FUNCTION pticker
  * Prints a status bar on the screen
  STORE SET("CONSOLE") TO setcon
  STORE SET("PRINTER") TO setprn
  SET CONSOLE ON
  SET PRINTER OFF
  @ 00,00 SAY SUBSTR(ticker_str,seg,77)
  IF setcon = 'OFF'
    SET CONSOLE OFF
  ENDIF
  IF setprn = 'ON'
    SET PRINTER ON
  ENDIF
  STORE IIF(seg=11,1,seg + 1) TO seg
  RETURN ''
  
FUNCTION ready2pr
  DO WHILE .NOT. PRINTSTATUS()
    IF .NOT. YESNO('Printer not ready! System is ready to try again...')
      RETURN .f.
    ENDIF
  ENDDO
  RETURN .t.
  
FUNCTION yesno
  PARAMETERS MESSAGE
  DEFINE WINDOW yesno FROM 10,02 TO 14,77 DOUBLE FLOAT SHADOW COLOR SCHEME 7
  STORE 'Yes' TO yesno
  ACTIVATE WINDOW yesno
  @ 00,01 SAY MESSAGE
  @ 02,01 SAY 'Continue? Yes/No:'
  DO WHILE .T.
    @ 02,19 PROMPT '\<Yes'
    @ 02,23 PROMPT '\<No'
    MENU TO yesno
    IF LASTKEY() = 13 ;
    .OR. (MROW() = 02 .AND. (MCOL() = 19 .OR. MCOL() = 20 .OR. MCOL() = 21 ;
    .OR.  MCOL() = 23 .OR. MCOL() = 24))
      EXIT
    ELSE
      ?? chr(7)
    ENDIF
  ENDDO
  RELEASE WINDOW yesno
  STORE IIF(yesno=1,.Y.,.N.) TO retval
  RETURN retval
  
FUNCTION wintitle
  PARAMETERS ctitle
  STORE WCOLS() TO clen
  STORE INT((clen - LEN(ctitle))/2) TO padding
  STORE SPACE(padding) + ctitle + SPACE((clen-LEN(ctitle))-padding) TO padtitle
  RETURN padtitle
  
  * Ŀ *
  *   SYSTEM PROCEDURES                                                   *
  *  *
  
PROCEDURE msg2user
  PARAMETERS message1, message2, message3
  IF message1 = 'CLOSE'
    DEACTIVATE WINDOW msg2user
  ELSE
    ACTIVATE WINDOW msg2user
    CLEAR
    @ 00,00 SAY SPACE(1) + LEFT(message1 + SPACE(71),71) + SPACE(1)
    @ 01,00 SAY SPACE(1) ;
    + LEFT(IIF(PARAMETERS() < 2, SPACE(71), message2) + SPACE(71),71) + SPACE(1)
    @ 02,00 SAY SPACE(1) ;
    + LEFT(IIF(PARAMETERS() < 3, SPACE(71), message3) + SPACE(71),71) + SPACE(1)
  ENDIF
  RETURN
  
PROCEDURE standby
  PARAMETERS msgwords
  DEFINE WINDOW standby FROM 17,02 TO 21,77 DOUBLE FLOAT SHADOW COLOR SCHEME 7
  ACTIVATE WINDOW standby
  @ 00,01 SAY msgwords
  @ 01,01
  WAIT '                < Press a key or click the mouse to continue. > '
  RELEASE WINDOW standby
  RETURN
  
* EOF
